(function(){
    if(!document.location.hash)
        return;

    const hash = document.location.hash.replace('#', '');
    if(!/^\d+$/.test(hash))
        return;

    location.href = hash + '.htm';
})();

document.onkeyup = function(e) {
    if(document.activeElement.nodeName === "INPUT" || document.activeElement.nodeName === "TEXTAREA") {
        return;
    }

    if(e.code === 'ArrowLeft' && (link = document.querySelector('link[rel="prev"]'))) {
        location.href = link.href;
    } else if(e.code === 'ArrowRight' && (link = document.querySelector('link[rel="next"]'))) {
        location.href = link.href;
    }

    if(e.code === 'Slash') {
        const modal = bootstrap.Modal.getOrCreateInstance(document.getElementById('searchModal'));

        if('gtag' in window) {
            gtag('event', 'link_click', {
                event_category: 'navigation',
                event_action: 'docSearchStart',
                event_label: location.href
            });
        }

        modal.show();
    }
};

if(!document.querySelector('#contentsModal .modal-body .toc')) {
    document.querySelector('#contentsModal .modal-body').innerHTML = document.querySelector('ul.toc').outerHTML;
}

window.addEventListener('DOMContentLoaded', (event) => {

});
if(searchINput = document.querySelector('.main-menu input[name="q"]')) {
    searchINput.addEventListener('blur', (e) => {
    e.currentTarget.value = '';
    });
}

// Search
const template = document.querySelector('#searchModal .list-group-item:first-child').outerHTML;
const templateNoResult = document.querySelector('#searchModal .list-group-item:last-child').outerHTML;
const resultsList = document.querySelector('#searchModal .list-group');
resultsList.innerHTML = '';
resultsList.classList.add('d-none');
const parser = new DOMParser();

document.getElementById('searchModal').addEventListener('shown.bs.modal', (e) => {
    document.getElementById('searchField').focus();
});
document.getElementById('searchModal').addEventListener('hidden.bs.modal', (e) => {
    document.getElementById('searchField').value = '';
    resultsList.innerHTML = '';
    resultsList.classList.add('d-none');
});
document.getElementById('searchModal').addEventListener('keyup', (e) => {
    e.stopPropagation();
    const index = document.activeElement.tabIndex;
    const length = document.querySelectorAll('#searchModal [tabindex]').length;
    const searchField = document.getElementById('searchField');
    if(e.code === 'ArrowUp') {
        if(index === 1) {
            document.querySelector('#searchModal [tabindex="' + (length) + '"]').focus();
        } else {
            document.querySelector('#searchModal [tabindex="' + (index - 1) + '"]').focus();
        }
    } else if(e.code === 'ArrowDown') {
        if(index === length) {
            searchField.focus();
        } else {
            document.querySelector('#searchModal [tabindex="' + (index + 1) + '"]').focus();
        }
    } else if(['Slash', 'ArrowLeft'].indexOf(e.code) > -1) {
        searchField.focus();
    } else if(searchField !== document.activeElement && ['Enter', 'ArrowRight'].indexOf(e.code) > -1) {
        document.querySelector('#searchModal [tabindex="' + index + '"] a').click();
        return false;
    } else if(searchField !== document.activeElement && e.key.length === 1 && /\w/.test(e.key)) {
        searchField.focus();
        searchField.value += e.key;
    }
});

if(document.getElementById('sideToc')) {
    window.addEventListener("resize", function() {
        const toc = document.getElementById('sideToc');
        const articleHeight = toc.parentNode.querySelector('article').parentNode.clientHeight;
        const tocWrapper = toc.querySelector('div:first-child');
        if(articleHeight < window.innerHeight) {
            if(!'oldMaxHeight' in toc) {
                toc.oldMaxHeight = tocWrapper.style.maxHeight;
            }
            tocWrapper.style.maxHeight = articleHeight + 'px';
        } else {
            tocWrapper.style.maxHeight = toc.oldMaxHeight;
        }
    });
    window.dispatchEvent(new Event('resize'));
}

document.getElementById('searchField').addEventListener('keyup', (e) => {
    if(e.target.value.length < 3) {
        resultsList.innerHTML = '';
        resultsList.classList.add('d-none');
        return;
    }
    const query = e.target.value
        // todo: Works wrong with cyrillic symbols, will probably do the same with all non-latin
        // .replaceAll(/\W+/igm, ' ')
        .replaceAll(/\b[a-z]{1}\b/igm, ' ')
        .replaceAll(/\s+/igm, ' ')
        .trim()
        .toLowerCase();
    const searchResults = []
    resultsList.innerHTML = '';
    resultsList.classList.add('d-none');

    search_index.forEach(function(topic) {
        let matchWords = [];
        const words = query.split(' ');
        words.unshift(query);
        words.forEach(function(word, index) {
            let occurrences = 0;
            const re = new RegExp(word, 'g');
            if(!(occurrences = (topic.text.match(re) || []).length)) {
                return;
            }
            matchWords.push({'word': word, 'occurrences': occurrences, 'wordsMatch': 0, 'phraseMatch': index === 0, 'position': topic.text.indexOf(word)});
        });
        if(matchWords.length) {
            let result = [];
            matchWords.forEach(function(matchWord, index) {
                if(index === 0) {
                    let preview = topic.text.substr(matchWord.position > 100 ? matchWord.position - 100 : 0,200 + matchWord.word.length).trim();
                    preview = preview.replaceAll(matchWord.word, '<span class="search-word">' + matchWord.word + '</span>');
                    matchWord.bc = topic.bc;
                    matchWord.href = topic.href;
                    matchWord.preview = preview;
                    result = matchWord;
                } else {
                    result.preview = result.preview.replaceAll(matchWord.word, '<span class="search-word">' + matchWord.word + '</span>');
                    result.occurrences += matchWord.occurrences;
                }
            });
            result.wordsMatch = matchWords.length === 1 ? 1 : matchWords.length;
            searchResults.push(result);
        }
    });

    if(searchResults.length === 0) {
        const node = parser.parseFromString(templateNoResult, 'text/html').querySelector('li');
        resultsList.classList.remove('d-none');
        resultsList.appendChild(node);
    } else {

        searchResults.sort(function(a, b) {
            if (a.occurrences > b.occurrences) {
                return -1;
            }
            if (a.occurrences < b.occurrences) {
                return 1;
            }
            return 0;
        });
        searchResults.sort(function(a, b) {
            if (a.wordsMatch > b.wordsMatch) {
                return -1;
            }
            if (a.wordsMatch < b.wordsMatch) {
                return 1;
            }
            return 0;
        });
        searchResults.sort(function(a, b) {
            if (a.phraseMatch > b.phraseMatch) {
                return -1;
            }
            if (a.phraseMatch < b.phraseMatch) {
                return 1;
            }
            return 0;
        });

        searchResults.forEach(function(searchResult, index) {
            let result = template
                .replace('#TITLE#', searchResult.bc)
                .replaceAll('#HREF#', searchResult.href)
                .replace('#TEXT#', '...' + searchResult.preview + '...')
                .replace('#TAB#', index + 2);
            const li = parser.parseFromString(result, 'text/html').querySelector('li');
            li.querySelectorAll('a').forEach(function (a) {
                a.addEventListener('click', function () {
                    if('gtag' in window) {
                        gtag('event', 'link_click', {
                            event_category: 'navigation',
                            event_action: 'docSearchSuccess',
                            event_label: 'query:' + document.getElementById('searchField').value + '|result:' + this.href
                        });
                    }
                });
            });
            resultsList.appendChild(li);
        });
        resultsList.classList.remove('d-none');
    }

});